Ipelib: ipe::PdfObj Class Reference

Ipelib

Public Member Functions | List of all members
ipe::PdfObj Class Referenceabstract
Ipe Base

`#include <ipepdfparser.h>`

Inherited by ipe::PdfArray, ipe::PdfBool, ipe::PdfDict, ipe::PdfName, ipe::PdfNull, ipe::PdfNumber, ipe::PdfRef, and ipe::PdfString.

## Public Member Functions
virtual | ~PdfObj ()=0
virtual const PdfNull * | null () const noexcept
virtual const PdfBool * | boolean () const noexcept
virtual const PdfNumber * | number () const noexcept
virtual const PdfString * | string () const noexcept
virtual const PdfName * | name () const noexcept
virtual const PdfRef * | ref () const noexcept
virtual const PdfArray * | array () const noexcept
virtual const PdfDict * | dict () const noexcept
virtual void | write (Stream &stream, const PdfRenumber *renumber=nullptr, bool inflate=false) const noexcept=0
String | repr () const noexcept

## Detailed Description

Abstract base class for PDF objects.

## Constructor & Destructor Documentation

## ◆ ~PdfObj()

PdfObj::~PdfObj | ( |  | ) |
| pure virtual

Pure virtual destructor.

## Member Function Documentation

## ◆ null()

const PdfNull * PdfObj::null | ( |  | ) | const
| virtualnoexcept

Return this object as PDF null object.

Reimplemented in ipe::PdfNull.

Referenced by ipe::PdfNull::PdfNull().

## ◆ boolean()

const PdfBool * PdfObj::boolean | ( |  | ) | const
| virtualnoexcept

Return this object as PDF bool object.

Reimplemented in ipe::PdfBool.

Referenced by ipe::PdfBool::PdfBool().

## ◆ number()

const PdfNumber * PdfObj::number | ( |  | ) | const
| virtualnoexcept

Return this object as PDF number object.

Reimplemented in ipe::PdfNumber.

Referenced by ipe::PdfResources::collect(), ipe::CairoPainter::executeStream(), ipe::PdfDict::getNumber(), ipe::PdfDict::getNumberArray(), ipe::PdfParser::getToken(), ipe::Face::glyphIndex(), ipe::PdfFile::parseObjectStream(), and ipe::PdfNumber::PdfNumber().

## ◆ string()

const PdfString * PdfObj::string | ( |  | ) | const
| virtualnoexcept

Return this object as PDF string object.

Reimplemented in ipe::PdfString.

Referenced by ipe::CairoPainter::executeStream(), and ipe::PdfString::PdfString().

## ◆ name()

const PdfName * PdfObj::name | ( |  | ) | const
| virtualnoexcept

Return this object as PDF name object.

Reimplemented in ipe::PdfName.

Referenced by ipe::PdfFile::catalog(), ipe::PdfResources::collect(), ipe::PdfDict::deflated(), ipe::CairoPainter::executeStream(), ipe::Face::Face(), ipe::Document::formatFromFilename(), ipe::PdfParser::getToken(), ipe::Face::glyphIndex(), ipe::PdfFile::parse(), and ipe::PdfName::PdfName().

## ◆ ref()

const PdfRef * PdfObj::ref | ( |  | ) | const
| virtualnoexcept

Return this object as PDF reference object.

Reimplemented in ipe::PdfRef.

Referenced by ipe::PdfResources::collect(), ipe::Latex::createLatexSource(), ipe::Face::Face(), ipe::PdfResourceBase::getDeep(), ipe::PdfParser::getToken(), ipe::PdfArray::obj(), ipe::PdfRef::PdfRef(), ipe::PdfResources::PdfResources(), and ipe::PdfWriter::~PdfWriter().

## ◆ array()

const PdfArray * PdfObj::array | ( |  | ) | const
| virtualnoexcept

Return this object as PDF array object.

Reimplemented in ipe::PdfArray.

Referenced by ipe::PdfFile::catalog(), ipe::PdfResources::collect(), ipe::Face::Face(), ipe::PdfDict::getNumberArray(), ipe::Face::glyphIndex(), ipe::PdfArray::PdfArray(), ipe::PdfResources::PdfResources(), and ipe::Latex::readPdf().

## ◆ dict()

const PdfDict * PdfObj::dict | ( |  | ) | const
| virtualnoexcept

Return this object as PDF dictionary object.

Reimplemented in ipe::PdfDict.

Referenced by ipe::PdfFile::catalog(), ipe::PdfResources::collect(), ipe::Latex::createLatexSource(), ipe::Face::Face(), ipe::Document::formatFromFilename(), ipe::PdfResourceBase::getDict(), ipe::PdfParser::getToken(), ipe::Face::glyphIndex(), ipe::PdfDict::PdfDict(), ipe::PdfResources::PdfResources(), ipe::Latex::readPdf(), ipe::PdfThumbnail::render(), ipe::PdfResourceBase::resourcesOfKind(), ipe::PdfViewBase::setPage(), and ipe::PdfWriter::~PdfWriter().

## ◆ write()

virtual void ipe::PdfObj::write | ( | Stream & | stream,
|  | const PdfRenumber * | renumber = `nullptr`,
|  | bool | inflate = `false`
| ) |  | const
| pure virtualnoexcept

Implemented in ipe::PdfDict, ipe::PdfArray, ipe::PdfRef, ipe::PdfName, ipe::PdfString, ipe::PdfNumber, ipe::PdfBool, and ipe::PdfNull.

Referenced by ipe::PdfArray::PdfArray(), ipe::PdfDict::PdfDict(), ipe::PdfName::PdfName(), ipe::PdfNull::PdfNull(), ipe::PdfNumber::PdfNumber(), ipe::PdfRef::PdfRef(), ipe::PdfString::PdfString(), repr(), ipe::PdfBool::value(), and ipe::PdfWriter::~PdfWriter().

## ◆ repr()

String PdfObj::repr | ( |  | ) | const
| noexcept

Return PDF representation of the object.

References write().

Referenced by ipe::PdfResources::collect(), and ipe::CairoPainter::executeStream().

The documentation for this class was generated from the following files:

- ipepdfparser.h
- ipepdfparser.cpp